#ifndef SS_DISPLAY_DWIN_H_
#define SS_DISPLAY_DWIN_H_
#include <inttypes.h>
#include <Arduino.h>

#include <SoftwareSerial.h>


/* Private macro -------------------------------------------------------------*/
 #define TFT_ID 0x00 //dwin
 
 
 #define Start_Byte 0xAA
 #define Hand_Shake 0x00
 #define CMD_SET_COLOR  0x40
 #define CMD_SET_FONT_PITCH 0x41
 #define CMD_SET_BACKGROUND_COLOR_By_XY 0x42
 #define CMD_SET_FRONT_COLOR_By_XY 0x43
 #define CMD_SET_CURSOR_MODE 0x44
 #define CMD_PRINT_STRING_8x8 0x53
 #define CMD_PRINT_STRING_16x16 0x54
 #define CMD_PRINT_STRING_32x32 0x55
 #define CMD_PRINT_STRING_12x12 0x6E
 #define CMD_PRINT_STRING_24x24 0x6F
 #define CMD_Put_Pixel_BK_Color 0x50
 #define CMD_Put_Pixel_FR_Color 0x51
 #define CMD_Line_BK_Color	 0x5D
 #define CMD_Line_FR_Color	 0x56
 #define CMD_Circle 0x57
 #define CMD_Rectangle 0x59
 #define CMD_Clear_Screen 0x52
 #define CMD_Full_Area_Front 0x5B
 #define CMD_Reverse_Area_Color 0x5C
 #define CMD_Move_Area_N_Pixel_L 0x60
 #define CMD_Move_Area_N_Pixel_R 0x61
 #define CMD_FullPic 0x70
 #define CMD_AreaPic 0x71
 #define CMD_IO1_PWM 0x5F

/* Private variables ---------------------------------------------------------*/
static uint8_t  endByte[4]={ 0xCC , 0x33 , 0xC3 , 0x3C };

class SS_Display_Dwin{
  public:
  SS_Display_Dwin(SoftwareSerial& serial,uint32_t bps);
  
  void SET_Color(uint16_t color1,uint16_t color2);
  void FullPicture (uint8_t Pic_No);
  void Line (uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint16_t frontcolor, uint16_t background);
  void Circle (uint8_t type,uint16_t x1,uint16_t y1,uint16_t r1,uint16_t color);
  void Rectangle (uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint16_t frontcolor, uint16_t background);
  void ClearScreen (uint16_t color);
  void FullAreaColor (uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint16_t color);
  void Area_Picture_Rectangle (uint16_t Pic_No ,uint16_t x1,uint16_t y1,uint16_t x2, uint16_t y2,uint16_t X,uint16_t Y);
  void Print_String(uint8_t Font_Size,uint16_t X,uint16_t Y,uint8_t *String);
  void Put_Pixel(uint16_t x,uint16_t y,uint16_t color);
  void Print_DAT(uint16_t X,uint16_t Y,uint8_t font, uint16_t DAT);
  void ReverseAreaColor (uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2);

  private:
  void writeEndByte();
  
  SoftwareSerial &_serial;
  uint32_t _bps; //bound rate serial
  
};

#endif
