#include "SS_Display_Dwin.h"
#include "TouchParser.h"
    
#include <SoftwareSerial.h>
SoftwareSerial mySerial(10,11);// RX, TX
SS_Display_Dwin displayOne(mySerial,9600);
TouchParser touch(mySerial);

uint16_t display_width = 320;
uint16_t display_height = 240;

void setup(){
	Serial.begin(9600);
	Serial1.begin(9600);
	Serial2.begin(9600);
	mySerial.begin(9600);
	
	Serial.println("Menu: ");
	Serial.println("a --> int to hex");
	Serial.println("b --> print string");
	Serial.println("c --> clear Screen");
	Serial.println("d --> print full picture");
	Serial.println("e --> crop out a frame from the picture");
	Serial.println("f --> Draw a circle");
	Serial.println("g --> Draw a line");
	Serial.println("i --> Reverse color");
	Serial.println("l --> Draw a rectagle");
	Serial.println("m --> Color a pixel in position X, Y");
	Serial.println("n --> Paint an area with a defined color");
}

void loop(){

	if(Serial.available()>0){
		char date = Serial.read();
		Serial.println("\n");
		Serial.print("Command received: "); Serial.println(date);
		
		//print number in hexadecimal
		if(date == 'a') {
			displayOne.Print_DAT(40,40,4,10);
			Serial.println("Printing an Hesadecimal");
		}
		
		//printing a string
		if(date == 'b'){
			displayOne.SET_Color(0xffff, 0x99ff);
			char *s = "Hello";
			Serial.println("Print the string");
			displayOne.Print_String(4,0,0,(uint8_t *) s);
			s = " Word";
			displayOne.Print_String(3,90,0,(uint8_t *) s);
			s = " good morning";
			displayOne.Print_String(2,0,100,(uint8_t *) s);
		}

		if(date == 'c') {
			Serial.println("Clear screen");
			displayOne.ClearScreen(100);
		}
		
		if(date == 'd'){
			Serial.println("Display first picture");
			displayOne.FullPicture (1); 
			Serial.println("delay of 3 seconds");
			delay(3000);
			Serial.println("Display second picture");
			displayOne.FullPicture (2); 
		}

		if(date=='e'){
			Serial.print("Paint picture in a rectagle area");
			displayOne.Area_Picture_Rectangle (0, 0, 0, display_width/2, display_height/2, 0, 0);
		}

		if(date=='f') {
			Serial.println("Drawing a circle");
			displayOne.SET_Color(0xffff, 0x99ff);
			displayOne.Circle(0,50,100,50, 0x33CC);
		}
		
		if(date=='g') {
			Serial.println("Drawing a line");
			displayOne.Line(20,50,100,255,0xffff, 0x33CC);
		}
		
		if(date=='i') {
			Serial.println("Reverse the color inside the selected area");
			displayOne.ReverseAreaColor(20,50,100,255);
		}
		
		if(date=='l') {
			Serial.println("Drawing a rectangle");
			displayOne.Rectangle(0,50,100,50, 0x33CC, 0xffff);
		}
		
		
		if(date=='m') {
			displayOne.Put_Pixel(100,100, 0xffff);
		}
		
		if(date=='n') {
			displayOne.FullAreaColor(0,0,display_width, display_height, 0xff33 );
		}
	}
	/*
	int x,y;
	if(displayOne.check_TP(x,y) == 1){
		displayOne.Show_TP_Position(x,y);
		Serial.print(x);
		Serial.print(" , ");
		Serial.println(y);
	}
	*/
	
	TouchEvent event = touch.read();

	if(event.event != kTouchNone) {
		Serial.print("X: "); Serial.print(event.x); Serial.print(", Y: "); Serial.print(event.y);
		
		if(event.event == kTouchPress) {
			Serial.print(", event: "); Serial.println("Press");
		} else if(event.event == kTouchRelease) {
			Serial.print(", event: "); Serial.println("Release");
		}else{
			Serial.println();
		}
	}
	
	
}
 
